;easy example for controller-board (www.frydaysoft.de)
;flash the 4 Leds 
;poll the HCT245 and put this data to HCT574

$include (mod51)

cseg at 0
USING 0
org 0000h
jmp start

; Highbyte A15..12 0 0 0 0
Offset_Y0  	equ 80h
Offset_Y1  	equ 90h
Offset_Y2  	equ 0a0h
Offset_Y3  	equ 0b0h
Offset_Y4  	equ 0c0h
Offset_Y5  	equ 0d0h
Offset_Y6  	equ 0e0h
Offset_Y7  	equ 0f0h

org 0040h
start:  
	mov SP,#30h	       ; Stackpointer to 30h
	mov SP,#30h	       ; Stackpointer to 30h
	mov R0,#1h
;-----------------------------------------------------------------------------
loop:
	jnb P1.2,loop
	mov a,R0
	inc a
	orl a,#0fh
	mov R0,a
	call wait
	mov P1,R0
	mov b,#Offset_Y2
	call in_io
	mov b,#Offset_Y1
	call out_io
	jnb P1.0,loop
	call wait
	call wait
	call wait
	jnb P1.1,loop
	call wait
	call wait
	call wait
	jmp loop

;-----------------------------------------------------------------------------
wait:
	mov b,#80h
wait2:
	mov a,#00h
	djnz acc,$
	djnz b,wait2
	ret

;--------------------------------------------
;in acc is data in b is IO-low-adresse
out_io:
	push dpl
	push dph
	mov dpl,#0
	mov dph,b
	movx @DPTR,a
	pop dph
	pop dpl
	ret

;--------------------------------------------
;in acc is data in b is IO-low-adresse
in_io:
	push dpl
	push dph
	mov dpl,#0
	mov dph,b
	movx a,@DPTR
	pop dph
	pop dpl
	ret

;--------------------------------------------


end
